<?php
  include_once('./00config.php');
  header("Content-Type: text/html; charset=ISO-8859-1");
  header("Last-Modified: ".gmdate("D, d M Y H:i:s", time())." GMT");;
  header("Expires: ".gmdate("D, d M Y H:i:s", time())." GMT");
  $title = "Game Account Registration";
  include('./00header.php');
?>
<h2 align="center"><?php echo $title ?></h2>
<?php
error_reporting(0);

// step 0 - empty post
// step 1 - check id
// step 2 - register

if ( empty($_POST) ) {
  $step = 0;
} else if ( !empty($_POST['step']) && $_POST['step'] == "1" ) {
  $step = 1;
} else if ( !empty($_POST['step']) && $_POST['step'] == "2" ) {
  $step = 2;
} else if ( !empty($_POST['step']) && $_POST['step'] == "3" ) {
  $step = 3;
} else {
  $step = 0;
}

if ($step == 0) {
echo <<<END
<p align="center">Please think of a Login ID. This ID should be different than your in game character name.<br>It has to be 4-10 alphanumeric. All lower case. Must begin with alpha.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td><input type="text" name="id" size="20" maxlength="10" value=""></td></tr>
    <input type="hidden" name="step" value="1">
    <tr><td align="center" colspan="2"><input type="submit" name="submit" value="Check ID for availability"></td></tr>
  </table>
</form>
<p align="center"><b>Click Check ID Once and Wait. Do not Reload or ReSubmit until it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
} // step 0

if ($step == 1) {
$id = trim($_POST['id']);
$id = strtolower($id);
if (strlen($id) < 4 || strlen($id) > 10 || !preg_match('/^[a-z]+[a-z0-9]*$/', $id)) {
  echo "Login ID is invalid. 4-10 Alphanumeric. All lower case. Must begin with alpha.<br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}

$str = "";
$str .= "id=".htmlentities(urlencode($id));
$str .= "&verify=".htmlentities(urlencode($magickey));

$file = file_get_contents ("{$backend}idcheck.php?".$str);
if ($file === false) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
if (trim($file) == "Passed") {
echo <<<END
<font color="red">Login ID already exist. Please use another one.</font><br>
<p align="center">Please think of a Login ID. This ID should be different than your in game character name.<br>It has to be 4-10 alphanumeric. All lower case. Must begin with alpha.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td><input type="text" name="id" size="20" maxlength="10" value=""></td></tr>
    <input type="hidden" name="step" value="1">
    <tr><td align="center" colspan="2"><input type="submit" name="submit" value="Check ID for availability"></td></tr>
  </table>
</form>
<p align="center"><b>Click Check ID Once and Wait. Do not Reload or ReSubmit until it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
}

echo <<<END
<p align="center">You should only create your account with REAL information. You may not be able to retrieve your account when you forgot these information.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td>$id</td></tr>
    <input type="hidden" name="id" value="$id">
    <tr><td align="right">Password:</td><td><input type="password" name="password" size="20" maxlength="10" value=""></td><td align="left">4-10 alphanumeric</td></tr>
    <tr><td align="right">Confirm Password:</td><td><input type="password" name="confirmpassword" size="20" maxlength="10" value=""></td><td align="left">4-10 alphanumeric</td></tr>
    <tr><td align="right">Real Name:</td><td><input type="text" name="name" size="20" maxlength="20" value=""></td><td align="left">5-20 alphabets and space</td></tr>
    <tr><td align="right">Birthday:</td><td><input type="text" name="birthday" size="20" maxlength="10" value="YYYY/MM/DD"></td><td align="left">YYYY/MM/DD</td></tr>
    <tr><td align="right">Country:</td><td><input type="text" name="country" size="20" maxlength="20" value=""></td><td align="left">2-20 alphabets and space</td></tr>
    <tr><td align="right">Email:</td><td><input type="text" name="email" size="20" maxlength="40" value=""></td><td align="left">7-40 email format</td></tr>
    <tr><td align="right">Question 1:</td><td><input type="text" name="question1" size="20" maxlength="20" value="">?</td><td align="left">3-20 alphanumeric and space</td></tr>
    <tr><td align="right">Answer 1:</td><td><input type="text" name="answer1" size="20" maxlength="12" value=""></td><td align="left">2-12 alphanumeric and space</td></tr>
    <tr><td align="right">Question 2:</td><td><input type="text" name="question2" size="20" maxlength="20" value="">?</td><td align="left">3-20 alphanumberic and space</td></tr>
    <tr><td align="right">Answer 2:</td><td><input type="text" name="answer2" size="20" maxlength="12" value=""></td><td align="left">2-12 alphanumeric and space</td></tr>
    <tr><td align="right">Home Phone:</td><td><input type="text" name="phone" size="20" maxlength="14" value=""></td><td align="left">6-14 numbers</td></tr>
    <tr><td align="right">Cell Phone(optional):</td><td><input type="text" name="cellphone" size="20" maxlength="13" value=""></td><td align="left">6-13 numbers</td></tr>
    <input type="hidden" name="step" value="2">
    <tr><td align="center" colspan="3"><input type="submit" name="submit" value="Create Account"></td></tr>
  </table>
</form>
<p align="center"><b>Click Create Account Once and Wait. Do not Reload or ReSubmit unless it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
} // step 1

if ($step == 2) {
$passCheck = true;

$id = trim($_POST['id']);
$id = strtolower($id);
if (strlen($id) < 4 || strlen($id) > 10 || !preg_match('/^[a-z]+[a-z0-9]*$/', $id)) {
  echo '<font color="red">Login ID is invalid. 4-10 Alphanumeric. All lower case. Must begin with alpha.</font><br>';
  $passCheck = false;
}

$password = trim($_POST['password']);
if (strlen($password) < 4 || strlen($password) > 10 || !preg_match('/^[a-zA-Z0-9]+$/', $password)) {
  echo '<font color="red">Password is invalid. 4-10 Alphanumeric.</font><br>';
  $passCheck = false;
}

$confirmpassword = trim($_POST['confirmpassword']);
if ($confirmpassword != $password) {
  echo '<font color="red">Confirm Password does not match Password.</font><br>';
  $passCheck = false;
}

$name = trim($_POST['name']);
if (strlen($name) < 5 || strlen($name) > 20 || !preg_match('/^[ a-zA-Z]+$/', $name)) {
  echo '<font color="red">Real Name is invalid. 5-20 Alphabets.</font><br>';
  $passCheck = false;
}

$country = trim($_POST['country']);
if (strlen($country) < 2 || strlen($country) > 20 || !preg_match('/^[ a-zA-Z]+$/', $country)) {
  echo '<font color="red">Country is invalid.</font><br>';
  $passCheck = false;
}

$phone = trim($_POST['phone']);
if (strlen($phone) < 6 || strlen($phone) > 14 || !preg_match('/^[ \(\)\.\-0-9]+$/', $phone)) {
  echo '<font color="red">Phone Number is invalid. 6-14 Numbers.</font><br>';
  $passCheck = false;
}

$cellphone = trim($_POST['cellphone']);
if (strlen($cellphone) != 0 && (strlen($cellphone) < 6 || strlen($cellphone) > 13 || !preg_match('/^[ \(\)\.\-0-9]+$/', $cellphone))) {
  echo '<font color="red">Cell Phone Number is invalid. 6-13 Numbers.</font><br>';
  $passCheck = false;
}

$question1 = trim($_POST['question1']);
if (strlen($question1) < 3 || strlen($question1) > 20 || !preg_match('/^[ a-zA-Z0-9]+$/', $question1)) {
  echo '<font color="red">Question 1 is invalid. 3-20 characters limit. Alphanumeric. Space allowed. No need ? at the end.</font><br>';
  $passCheck = false;
}

$answer1 = trim($_POST['answer1']);
if (strlen($answer1) < 2 || strlen($answer1) > 12 || !preg_match('/^[ a-zA-Z0-9]+$/', $answer1)) {
  echo '<font color="red">Answer 1 is invalid. 2-12 Alphanumeric. Space allowed. No Dot at the end.</font><br>';
  $passCheck = false;
}

$question2 = trim($_POST['question2']);
if (strlen($question2) < 3 || strlen($question2) > 20 || !preg_match('/^[ a-zA-Z0-9]+$/', $question2)) {
  echo '<font color="red">Question 2 is invalid. 3-20 characters limit. Alphanumeric. Space allowed. No need ? at the end.</font><br>';
  $passCheck = false;
}

$answer2 = trim($_POST['answer2']);
if (strlen($answer2) < 2 || strlen($answer2) > 12 || !preg_match('/^[ a-zA-Z0-9]+$/', $answer2)) {
  echo '<font color="red">Answer 2 is invalid. 2-12 Alphanumeric. Space allowed. No Dot at the end.</font><br>';
  $passCheck = false;
}

$email = trim($_POST['email']);
if (strlen($email) < 7 || strlen($email) > 40 || preg_match("/(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/",$email) || !preg_match("/^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/",$email)) {
  echo '<font color="red">Email is invalid.</font><br>';
  $passCheck = false;
}

$birthday = trim($_POST['birthday']);
list($Year, $Month, $Day)=explode('/',$birthday);
if (strlen($birthday) < 10 || strlen($birthday) > 10 || strlen($Year) != 4 || strlen($Month) != 2 || strlen($Day) != 2 || !checkdate($Month, $Day, $Year)) {
  echo '<font color="red">Birthday is invalid. Must be in the form YYYY/MM/DD. Use 04 for April etc.</font><br>';
  $passCheck = false;
}
if ((intval(date("Y"))-intval($Year)) < 5 || (intval(date("Y"))-intval($Year)) > 95) {
  echo '<font color="red">Birthday is out of range. Too young or Too old to play. :P</font><br>';
  $passCheck = false;
}

if ($passCheck == false) {
echo <<<END
<p align="center">You should only create your account with REAL information. You may not be able to retrieve your account when you forgot these information.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td>$id</td></tr>
    <input type="hidden" name="id" value="$id">
    <tr><td align="right">Password:</td><td><input type="password" name="password" size="20" maxlength="10" value=""></td><td align="left">4-10 alphanumeric</td></tr>
    <tr><td align="right">Confirm Password:</td><td><input type="password" name="confirmpassword" size="20" maxlength="10" value=""></td><td align="left">4-10 alphanumeric</td></tr>
    <tr><td align="right">Real Name:</td><td><input type="text" name="name" size="20" maxlength="20" value="$name"></td><td align="left">5-20 alphabets and space</td></tr>
    <tr><td align="right">Birthday:</td><td><input type="text" name="birthday" size="20" maxlength="10" value="$birthday"></td><td align="left">YYYY/MM/DD</td></tr>
    <tr><td align="right">Country:</td><td><input type="text" name="country" size="20" maxlength="20" value="$country"></td><td align="left">2-20 alphabets and space</td></tr>
    <tr><td align="right">Email:</td><td><input type="text" name="email" size="20" maxlength="40" value="$email"></td><td align="left">7-40 email format</td></tr>
    <tr><td align="right">Question 1:</td><td><input type="text" name="question1" size="20" maxlength="20" value="$question1">?</td><td align="left">3-20 alphanumeric and space</td></tr>
    <tr><td align="right">Answer 1:</td><td><input type="text" name="answer1" size="20" maxlength="12" value="$answer1"></td><td align="left">2-12 alphanumeric and space</td></tr>
    <tr><td align="right">Question 2:</td><td><input type="text" name="question2" size="20" maxlength="20" value="$question2">?</td><td align="left">3-20 alphanumberic and space</td></tr>
    <tr><td align="right">Answer 2:</td><td><input type="text" name="answer2" size="20" maxlength="12" value="$answer2"></td><td align="left">2-12 alphanumeric and space</td></tr>
    <tr><td align="right">Home Phone:</td><td><input type="text" name="phone" size="20" maxlength="14" value="$phone"></td><td align="left">6-14 numbers</td></tr>
    <tr><td align="right">Cell Phone(optional):</td><td><input type="text" name="cellphone" size="20" maxlength="13" value="$cellphone"></td><td align="left">6-13 numbers</td></tr>
    <input type="hidden" name="step" value="2">
    <tr><td align="center" colspan="3"><input type="submit" name="submit" value="Create Account"></td></tr>
  </table>
</form>
<p align="center"><b>Click Create Account Once and Wait. Do not Reload or ReSubmit unless it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
}

$memo1 = $country;
$memo2 = getenv("REMOTE_ADDR");

$str = "";
$str .= "id=".htmlentities(urlencode($id));
$str .= "&verify=".htmlentities(urlencode($magickey));

$file = file_get_contents ("{$backend}idcheck.php?".$str);
if ($file === false) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
if ($file == "Passed") {
  echo 'Login ID already exist. Please use another one.<br><br>';
  echo "<a href=\"register.php\">Restart Registration</a><br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}

$str = "";
$str .= "id=".htmlentities(urlencode($id));
$str .= "&password=".htmlentities(urlencode($password));
$str .= "&name=".htmlentities(urlencode($name));
$str .= "&country=".htmlentities(urlencode($country));
$str .= "&phone=".htmlentities(urlencode($phone));
$str .= "&cellphone=".htmlentities(urlencode($cellphone));
$str .= "&question1=".htmlentities(urlencode($question1));
$str .= "&answer1=".htmlentities(urlencode($answer1));
$str .= "&question2=".htmlentities(urlencode($question2));
$str .= "&answer2=".htmlentities(urlencode($answer2));
$str .= "&email=".htmlentities(urlencode($email));
$str .= "&birthday=".htmlentities(urlencode($birthday));
$str .= "&memo1=".htmlentities(urlencode($memo1));
$str .= "&memo2=".htmlentities(urlencode($memo2));
$str .= "&verify=".htmlentities(urlencode($magickey));

$file = file_get_contents ("{$backend}register3.php?".$str);
if ($file === false) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
if ($file == "Passed") {
  echo 'Account was created successfully.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
} else {
  echo 'Account was not created. Server encountered an error while processing your info. Please re-register.<br><br>';
  echo "<a href=\"register.php\">Restart Registration</a><br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}

} // step 2
?>
