<?php
  include_once('./00config.php');
  header("Content-Type: text/html; charset=ISO-8859-1");
  header("Last-Modified: ".gmdate("D, d M Y H:i:s", time())." GMT");;
  header("Expires: ".gmdate("D, d M Y H:i:s", time())." GMT");
  $title = "Game Account Password Change";
  include('./00header.php');
?>
<h2 align="center"><?php echo $title ?></h2>
<?php
error_reporting(0);

// step 0 - empty post
// step 1 - change password

if ( empty($_POST) ) {
  $step = 0;
} else if ( !empty($_POST['step']) && $_POST['step'] == "1" ) {
  $step = 1;
} else {
  $step = 0;
}

if ($step == 0) {
echo <<<END
<p align="center">Please think of a Login ID. This ID should be different than your in game character name.<br>It has to be 4-10 alphanumeric. All lower case. Must begin with alpha.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">LoginID:</td><td><input type="text" name="id" size="10" maxlength="10"></td></tr>
    <tr><td align="right">Current Password:</td><td><input type="password" name="oldpass" size="10" maxlength="10" value=""></td></tr>
    <tr><td align="right">New Password:</td><td><input type="password" name="newpass" size="10" maxlength="10" value=""></td></tr>
    <tr><td align="right">Repeat:</td><td><input type="password" name="confirm" size="10" maxlength="10" value=""></td></tr>
    <input type="hidden" name="step" value="1">
    <tr><td align="right"><input type="submit" value="Change Password"></td><td><input type="Reset" value="Reset"></td></tr>
  </table>
</form>
<p align="center"><b>Click Change Password Once and Wait. Do not Reload or ReSubmit until it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
} // step 0

if ($step == 1) {
$passCheck = true;

$id = urldecode($_POST['id']);
$id = strtolower($id);
if (!preg_match('/^[a-z]+[a-z0-9]*$/', $id)) {
  echo '<font color="red">Login ID is invalid. Alphanumeric. All lower case. Must begin with alpha.</font><br>';
  $passCheck = false;
}

$oldpass = urldecode($_POST['oldpass']);
if (!preg_match('/^[a-zA-Z0-9]+$/', $oldpass)) {
  echo '<font color="red">Old Password is invalid. Alphanumeric.</font><br>';
  $passCheck = false;
}

$newpass = urldecode($_POST['newpass']);
if (strlen($newpass) < 4 || strlen($newpass) > 10 || !preg_match('/^[a-zA-Z0-9]+$/', $newpass)) {
  echo '<font color="red">New Password is invalid. 4-10 Alphanumeric.</font><br>';
  $passCheck = false;
}

$confirm = urldecode($_POST['confirm']);
if ($confirm != $newpass) {
  echo '<font color="red">Confirm Password does not match New Password.</font><br>';
  $passCheck = false;
}

if ($passCheck == false) {
echo <<<END
<p align="center">You should only create your account with REAL information. You may not be able to retrieve your account when you forgot these information.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">LoginID:</td><td><input type="text" name="id" size="10" maxlength="10"></td></tr>
    <tr><td align="right">Current Password:</td><td><input type="password" name="oldpass" size="10" maxlength="10" value=""></td></tr>
    <tr><td align="right">New Password:</td><td><input type="password" name="newpass" size="10" maxlength="10" value=""></td></tr>
    <tr><td align="right">Repeat:</td><td><input type="password" name="confirm" size="10" maxlength="10" value=""></td></tr>
    <input type="hidden" name="step" value="1">
    <tr><td align="right"><input type="submit" value="Change Password"></td><td><input type="Reset" value="Reset"></td></tr>
  </table>
</form>
<p align="center"><b>Click Change Password Once and Wait. Do not Reload or ReSubmit unless it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
}

$str = "";
$str .=  "id=".htmlentities(urlencode($id));
$str .= "&verify=".htmlentities(urlencode($magickey));

$file = file_get_contents ("{$backend}idcheck.php?".$str);
if ($file === false) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
if (trim($file) == "Failed") {
  echo 'Login ID or Password is Invalid. Please try again.<br><br>';
  echo "<a href=\"pwchange.php\">Restart Password Change</a><br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}

$str = "";
$str .=  "id=".htmlentities(urlencode($id));
$str .= "&oldpass=".htmlentities(urlencode($oldpass));
$str .= "&newpass=".htmlentities(urlencode($newpass));
$str .= "&verify=".htmlentities(urlencode($magickey));

$file = file_get_contents ("{$backend}pwchange.php?".$str);
if ($file === false) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
if (trim($file) == "Passed") {
  echo 'Password has been changed successfully.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
} else {
  echo 'Login ID or Password is Invalid. Please try again.<br><br>';
  echo "<a href=\"pwchange.php\">Restart Password Change</a><br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}

} // step 2
?>
