<?php
  include_once('./00config.php');
  header("Content-Type: text/html; charset=ISO-8859-1");
  header("Last-Modified: ".gmdate("D, d M Y H:i:s", time())." GMT");;
  header("Expires: ".gmdate("D, d M Y H:i:s", time())." GMT");
  $title = "Game Account Password Retrieval";
  include('./00header.php');
?>
<h2 align="center"><?php echo $title ?></h2>
<?php
error_reporting(0);

// step 0 - empty post
// step 1 - id get questions
// step 2 - retrieval

if ( empty($_POST) ) {
  $step = 0;
} else if ( !empty($_POST['step']) && $_POST['step'] == "1" ) {
  $step = 1;
} else if ( !empty($_POST['step']) && $_POST['step'] == "2" ) {
  $step = 2;
} else {
  $step = 0;
}

if ($step == 0) {
echo <<<END
<p align="center">To use this service, you must know your LoginID, Date of Birth, and answers to your questions.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td><input type="text" name="id" size="20" maxlength="10" value=""></td></tr>
    <input type="hidden" name="step" value="1">
    <tr><td align="center" colspan="2"><input type="submit" name="submit" value="Next"></td></tr>
  </table>
</form>
<p align="center"><b>Click Next Once and Wait. Do not Reload or ReSubmit until it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
} // step 0

if ($step == 1) {
$id = trim($_POST['id']);
$id = strtolower($id);
if (strlen($id) < 4 || strlen($id) > 10 || !preg_match('/^[a-z]+[a-z0-9]*$/', $id)) {
  echo "Login ID is invalid. 4-10 Alphanumeric. All lower case. Must begin with alpha.<br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}

$str = "";
$str .=  "id=".htmlentities(urlencode($id));
$str .= "&verify=".htmlentities(urlencode($magickey));

$idPassed = file_get_contents ("{$backend}idcheck.php?".$str);
if ($idPassed === false) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}

$str = "";
$str .=  "id=".htmlentities(urlencode($id));
$str .= "&verify=".htmlentities(urlencode($magickey));

$questionFile = file_get_contents ("{$backend}getQuestions.php?".$str);
if (!$questionFile) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
list($getQuestionPassed, $q1, $q2) = explode("\n", $questionFile);

if ($idPassed == "Failed" || $getQuestionPassed == "Failed") {
echo <<<END
<font color="red">Login ID does not exist. Please try again.</font><br>
<p align="center">To use this service, you must know your LoginID, Date of Birth, and answers to your questions.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td><input type="text" name="id" size="20" maxlength="10" value=""></td></tr>
    <input type="hidden" name="step" value="1">
    <tr><td align="center" colspan="2"><input type="submit" name="submit" value="Next"></td></tr>
  </table>
</form>
<p align="center"><b>Click Next Once and Wait. Do not Reload or ReSubmit until it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
}

echo <<<END
<p align="center">Please fill in all the boxes. They are NOT case sensitive, but they are letter sensitive.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td>$id</td></tr>
    <input type="hidden" name="id" value="$id">
    <tr><td align="right">Your name:</td><td><input type="text" name="name" size="25" maxlength="20" value=""></td></tr>
    <tr><td align="right">Your date of birth:</td><td><input type="text" name="birthday" size="25" maxlength="10" value="YYYY/MM/DD"></td></tr>
    <tr><td align="right">Question 1:</td><td>$q1?</td></tr>
    <input type="hidden" name="question1" value="$q1">
    <tr><td align="right">Answer 1:</td><td><input type="text" name="answer1" size="25" maxlength="12" value=""></td></tr>
    <tr><td align="right">Question 2:</td><td>$q2?</td></tr>
    <input type="hidden" name="question2" value="$q2">
    <tr><td align="right">Answer 2:</td><td><input type="text" name="answer2" size="25" maxlength="12" value=""></td></tr>
    <input type="hidden" name="step" value="2">
    <tr><td align="right"><input type="submit" value="Submit"></td><td><input type="Reset" value="Reset"></td></tr>
  </table>
</form>
<p align="center"><b>Click Submit Once and Wait. Do not Reload or ReSubmit unless it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
} // step 1

if ($step == 2) {
$passCheck = true;

$id = urldecode($_POST['id']);
$q1 = urldecode($_POST['question1']);
$q2 = urldecode($_POST['question2']);

$name = urldecode($_POST['name']);
if (strlen($name) < 5 || strlen($answer1) > 20 || !preg_match('/^[ a-zA-Z]+$/', $name)) {
  echo '<font color="red">Name is invalid. 5-20 Alphabets. Space allowed.</font><br>';
  $passCheck = false;
}

$birthday = urldecode($_POST['birthday']);
list($Year, $Month, $Day)=explode('/',$birthday);
if (strlen($birthday) < 10 || strlen($birthday) > 10 || strlen($Year) != 4 || strlen($Month) != 2 || strlen($Day) != 2 || !checkdate($Month, $Day, $Year)) {
  echo '<font color="red">Birthday is invalid. Must be in the form YYYY/MM/DD. Use 04 for April etc.</font><br>';
  $passCheck = false;
}

$answer1 = urldecode($_POST['answer1']);
if (strlen($answer1) < 2 || strlen($answer1) > 12 || !preg_match('/^[ a-zA-Z0-9]+$/', $answer1)) {
  echo '<font color="red">Answer 1 is invalid. 2-12 Alphanumeric. Space allowed. No Dot at the end.</font><br>';
  $passCheck = false;
}

$answer2 = urldecode($_POST['answer2']);
if (strlen($answer2) < 2 || strlen($answer2) > 12 || !preg_match('/^[ a-zA-Z0-9]+$/', $answer2)) {
  echo '<font color="red">Answer 2 is invalid. 2-12 Alphanumeric. Space allowed. No Dot at the end.</font><br>';
  $passCheck = false;
}

if ($passCheck == false) {
echo <<<END
<p align="center">Please fill in all the boxes. They are NOT case sensitive, but they are letter sensitive.</p>
<form action="$_SERVER[PHP_SELF]" method="post">
  <table align="center">
    <tr><td align="right">Login ID:</td><td>$id</td></tr>
    <input type="hidden" name="id" value="$id">
    <tr><td align="right">Your name:</td><td><input type="text" name="name" size="25" maxlength="20" value="$name"></td></tr>
    <tr><td align="right">Your date of birth:</td><td><input type="text" name="birthday" size="25" maxlength="10" value="$birthday"></td></tr>
    <tr><td align="right">Question 1:</td><td>$q1?</td></tr>
    <tr><td align="right">Answer 1:</td><td><input type="text" name="answer1" size="25" maxlength="12" value="$answer1"></td></tr>
    <tr><td align="right">Question 2:</td><td>$q2?</td></tr>
    <tr><td align="right">Answer 2:</td><td><input type="text" name="answer2" size="25" maxlength="12" value="$answer2"></td></tr>
    <input type="hidden" name="step" value="2">
    <tr><td align="right"><input type="submit" value="Submit"></td><td><input type="Reset" value="Reset"></td></tr>
  </table>
</form>
<p align="center"><b>Click Submit Once and Wait. Do not Reload or ReSubmit unless it gives you an error.</b></p>
END;
  include('./00footer.php');
  exit(0);
}

$str = "";
$str .= "id=".htmlentities(urlencode($id));
$str .= "&name=".htmlentities(urlencode($name));
$str .= "&answer1=".htmlentities(urlencode($answer1));
$str .= "&answer2=".htmlentities(urlencode($answer2));
$str .= "&birthday=".htmlentities(urlencode($birthday));
$str .= "&verify=".htmlentities(urlencode($magickey));

$file = file_get_contents ("{$backend}pwretrieval.php?".$str);
if ($file === false) {
  echo 'Server down or unreachable. Please try again later.<br><br>';
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
list($retrievalPassed, $password) = explode("\n", $file);

if ($retrievalPassed == "Passed") {
  echo "Your password is ", $password, "<br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
} else {
  echo 'Your info does not match with our records. Please try again later.<br><br>';
  echo "<a href=\"pwretrieval.php\">Restart Password Retrieval</a><br><br>";
  echo "<a href=\"{$forums}\">Goto {$forumsname}</a><br>";
  include('./00footer.php');
  exit(0);
}
} // step 2
?>
